/*
 * ptar - PROJET ESIAL RS 2011/2012
 * Copyright (C) 2011 Julien VAUBOURG / Valentin KELLER
 * Contact <julien@vaubourg.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "ptar.h"

#ifndef _BSD_SOURCE
	#define _BSD_SOURCE
#endif

/*
 * Extrait un peripherique de caracteres ou de blocs
 * @header_t Informations en provenance du thread
 * @type Type de device (S_IFCHR ou S_IFBLK)
 * @return Nombre d'erreurs rencontrees
 */
unsigned int extract_device(header_for_thread* header_t, unsigned int type) {
	unsigned int mode;
	dev_t dev;
	mode = header_t->attr.mode | type;
	dev = makedev(header_t->attr.minor, header_t->attr.major);
	
	mknod(header_t->attr.fn_with_path, mode, dev);

	if(errno == EPERM) {
		fprintf(
			stderr,
			"[ERREUR] %s : vous devez avoir des droits root pour creer un peripherique special\n",
			header_t->attr.fn_with_path
		);

		return 1;
	}

	return 0;
}
