/*
 * ptar - PROJET ESIAL RS 2011/2012
 * Copyright (C) 2011 Julien VAUBOURG / Valentin KELLER
 * Contact <julien@vaubourg.com>
 * 
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */

#include "ptar.h"

/*
 * Extrait un repertoire de l'archive en cours
 * @header_t Informations en provenance du thread
 * @return Nombre d'erreurs rencontrees
 */
unsigned int extract_dir(header_for_thread* header_t) {
	
	/* Si le dossier existe deja par l'intermediaire de extract_dirs, il ne
	 * se passe rien */
	mkdir(header_t->attr.fn_with_path, header_t->attr.mode);

	return 0;
}

/*
 * Extrait du nom de fichier les differents repertoires qui composent son
 * chemin, pour les creer un par s'il n'existent pas. Leurs attributs seront
 * modifies lorsque le tar donnera le header qui leur correspond
 * @filename Nom de fichier a examiner
 * @return Nombre d'erreurs rencontrees
 */
unsigned int extract_dirs(char* filename) {
	char* p = filename;
	FILE* dir;

	while((p = strchr(p, '/')) != NULL) {
		*p = '\0';

		if((dir = fopen(filename, "r")))
			fclose(dir);
		else
			mkdir(filename, 0755);

		*p++ = '/';
	}

	return 0;
}
